/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef TOOL_DATAFILE_HXX_
# define TOOL_DATAFILE_HXX_

# include <fstream>
# include "datafile.hh"

namespace tool
{

  inline
  datafile::datafile(const std::string& filename): filename_ (filename)
  {
  }


  inline
  datafile::operator std::ostream& ()
  {
    if (not filestream_)
      filestream_.reset(new std::ofstream (filename_.c_str(),
					   std::ofstream::out |
					   std::ofstream::app));
    return *filestream_;
  }

  template <class T>
  std::ostream&
  datafile::operator << (const T& data)
  {
    return static_cast<std::ostream&> (*this) << data;
  }

} // End of namespace tool.

#endif // ! TOOL_DATAFILE_HXX_
